from nmf_morph import NMFMorph
from untwist.data import Wave
from untwist.transforms import STFT, ISTFT
from rtpghi import pghi

src = "audio/Tremblay-BaB-HumDC-M.wav"
tgt = "audio/Tremblay-SA-UprightPianoPedalWide.wav"
name = "humpiano"

fft_size = 2048
hop_size = 512
p = 0.9

s = Wave.read(src).to_mono()
t = Wave.read(tgt).to_mono()

stft = STFT(fft_size=fft_size, hop_size = hop_size)
istft = ISTFT(fft_size=fft_size, hop_size = hop_size)

S = stft.process(s).magnitude()
T = stft.process(t).magnitude()

m = NMFMorph()
m.analyze(S, T, p)

for f in [0, 0.25, 0.5, 0.75, 0.95, 1]:
    Y = m.interpolate(f)
    y = istft.process(pghi(Y, fft_size, hop_size))
    y.write("out/%s%.2f.wav"%(name,f))
